\begin{table}[htb!]
    \center
    \begin{tabular}{llrrr}
        \toprule
        \textbf{Crate} &\textbf{Description} &\textbf{Debug / kB} &\textbf{Debug opt. / kB} &\textbf{Release / kB}\\
        \midrule
        bern\_espresso &Application &13.2 &13.2 &16.6\\
        ui &Graphical User Interface &274.5 &137.5 &138.2\\
        smoltcp &TCP/IP Stack &107.6 &42.3 &8.2\\
        stm32\_eth &Ethernet Driver &21.4 &3.2 &0.1\\
        ad7124 &ADC Driver &19.8 &15.6 &1.3\\
        board &Board Support Package &190.7 &11.3 &9.9\\
        stm32f7xx\_hal &Microcontroller HAL &33.7 &7.6 &0.1\\
        core &Rust Core library &36.9 &41.9 &10.8\\
        bern\_kernel &Bern RTOS &56.6 &16.6 &6.1\\
        &other &175.4 &141.8 &111.4\\
        \midrule
        \textbf{Total} & &\textbf{916.6} &\textbf{417.8} &\textbf{286.1}\\
        \bottomrule
    \end{tabular}
    \caption{Firmware binary size with different compiler optimization.}
    \label{tab:memory-footprint}
\end{table}